#!/bin/bash

# defaults #########################################

t="";
remove=0
cf=$(dirname $0)/mimp-gallery.conf
normalparms="-jq 80 -sc -880,-550 -ec 1,1 -fr 0.8,-1,-1,1 -fr 0.25,-1,-1,10"
thumbparms="-jq 80 -sc -240,-120 -fr 0.8,-1,-1,1 -fr 0.3,-1,-1,2"
fullparms="-jq 80 -sc -1600,-1000 -ec 2"
if test "$mimpfullparams" != "" ; then fullparms="$mimpfullparams"; fi 
if test "$mimpnormalparams" != "" ; then normalparms="$mimpnormalparams"; fi 
if test "$mimpthumbparams" != "" ; then thumbparms="$mimpthumbparams"; fi 
rt=0
mimp=$(dirname $0)/mimp

#####################################################


while test $# -gt 0 
do 
cmd=$1
#echo === cmd === $cmd 
case x"$cmd" in 
x--)      break;; 
x-t)      shift; t="$1" ;;
x-w)	  shift; rt=$1;;
x-'?'*)   set - '' ;;
x-h*)     set - '' ;;
x-r)      remove=1 ;;
x*)       break;;
esac
shift

done 

#echo ==== $*
#exit 

if test $# -eq 0
then 
echo "
purpose: 

  make html webpage from specified images

usage: 

  $0 [-t title] [-r] dirname images...

options: 

  -r    remove directory
  -t    set title for html pages 
  -w n  remove n words from image description

example:

  # make web page from files ../mypics/*.jpg place them into dir 
  # hello-webpage and set title hello world
  $0 -t 'hello world' hello-webpage  ../mypics/*.jpg
  
  
" 
exit 0

fi


#set 
#echo $*
#exit 

if test "$t" = "" ; then t="$1"; fi 

d=$1; 
shift 

if test $remove = 1; then rm -r $d; fi 

mkdir "$d" 

echo $t >"$d/config.new"
ls -1  "$@" >>"$d/config.new" 

cmp "$d/config.new"  "$d/config.old" 
if test $? = 0 ; then echo directory unchanged nothing to be done use -r to remove directory first; exit 0; fi

mkdir "$d"/fullsize
mkdir "$d"/normalsize
mkdir "$d"/thumbnails

cp $cf/*.png "$d"
cp $cf/image.html $cf/image-icons.html "$d"

rm "$d"/image-[0-9]*.html

nr=0
lastnr=$#
firstnr=1
prevnr=1

for f in "$@"
do 

let nr=nr+1
if test $nr -ne $lastnr; then let nextnr=nr+1;  fi

 
iname="$(basename "$f" | tr -c '0-z.\n' '-')"
hname="image-$nr.html"
name="$(basename "$f" .jpg)"
name=$(set - $name; shift $rt ; echo $*)

echo ==============================================================
echo processing file $name 
echo processing file $iname 
echo processing file $hname $firstnr $lastnr $prevnr $nextnr 

#grep -q -s "fullsize/$iname"  $d/$hname 
#if test $? = 0 ;then echo $hname OK ; continue; fi 
#read

$mimp -o "$d/fullsize/$iname"   $fullparms   "$f"
$mimp -o "$d/normalsize/$iname" $normalparms "$f"
$mimp -o "$d/thumbnails/$iname" $thumbparms  "$f"

sed "\
s~albumtitle~$t~;\
s~image-filename~normalsize/$iname~;\
s~image-fullsize~fullsize/$iname~;\
s~image-name~$name~;\
s~image-number~$nr/$lastnr~;\
s~last-image.html~image-$lastnr.html~;\
s~first-image.html~image-$firstnr.html~;\
s~next-image.html~image-$nextnr.html~;\
s~previous-image.html~image-$prevnr.html~\
" <"$d/image.html" >"$d/$hname"

prevnr=$nr

done 



(
while read l
do
 case "$l" in
 icons*) break;;
 *) echo $l;; 
 esac
done 

let nr=0;
let colnr=0;

for f in "$@"
do
let nr=nr+1
let colnr=colnr+1

# if test $colnr -gt 7 ; then echo "<br>" ; colnr=1; fi

iname="$(basename "$f" | tr -c '0-z.\n' '-' )"
echo "<a href=image-$nr.html > <img style=\"border: 0px solid\" src=\"thumbnails/$iname\" ></a>&nbsp"
done 
while read l; do echo $l; done
    

) <"$d/image-icons.html" >"$d/index-new.html"

echo setting title $t
sed "\
s~albumtitle~$t~\
" <"$d/index-new.html" >"$d/index.html"

mv "$d/config.new"  "$d/config.old"
rm "$d"/image.html "$d"/image-icons.html "$d"/index-new.html
cp "$d"/index.html "$d"/1.show-gallery.html 
cp "$d"/image-1.html "$d"/2.show-first.html
cp "$d"/image-$nr.html "$d"/3.show-last.html
